from vcCommand import *
from vcHelpers.Application import *
import os

app = getApplication()    
selection = app.SelectionManager

def execute_get_properties(arg):
  selecteds = selection.getSelection(VC_SELECTION_COMPONENT)
  if len(selecteds) == 1:
    selected = selecteds[0]
    
    command_uri = getCommandPath()[8:]
    head, tail = os.path.split(command_uri)  
    properties_txt = os.path.join(head, 'Properties.txt')     
        
    properties = selected.Properties
    properties.sort(key = lambda property: property.Group)    
    
    with open(properties_txt, 'w') as file:
      for property_name in [property.Name for property in properties]:
          file.write(property_name + '\n')
          
    os.startfile(properties_txt)
    
  else:
    print "Please select 1 component"

def execute_set_properties(arg):
  selecteds = selection.getSelection(VC_SELECTION_COMPONENT)
  if len(selecteds) == 1:
    selected = selecteds[0]
    
    command_uri = getCommandPath()[8:]
    head, tail = os.path.split(command_uri)  
    properties_txt = os.path.join(head, 'Properties.txt')     
    
    with open(properties_txt, 'r') as file:
      properties_names = [line.strip() for line in file if line != ""]
    
    for property_name_index, property_name in enumerate(properties_names):
      property = selected.getProperty(property_name)
      if property:
        property.Group = property_name_index * 10
    
    selection.clear()
    selection.setSelection(selected)
    
  else:
    print "Please select 1 component"
    
def OnStart():  
  global diag, ecat_uri, temp_uri, component_type
  diag = getDialog(Caption = "ReorderProperties")  
  
  get_properties = diag.addProperty("GetProperties", VC_BUTTON, execute_get_properties)
  set_properties = diag.addProperty("SetProperties", VC_BUTTON, execute_set_properties)
  
  diag.show()
  